=== test/test_use_cmake/CMakeLists.txt ===
# This test checks that it is possible to use the
# CMake artifacts generated by the build.

cmake_minimum_required(VERSION 3.1.0)
project(test_use)

file(GENERATE
  OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/main.cpp"
  CONTENT
    [=[
#include <portaudio.h>
int main()
{
  Pa_Initialize();
  Pa_Terminate();
}
]=]
)

find_package(PortAudio REQUIRED)

add_library(test_use_static STATIC "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")
add_library(test_use_shared SHARED "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")
add_executable(test_use_exe "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")

target_link_libraries(test_use_static PRIVATE portaudio)
target_link_libraries(test_use_shared PRIVATE portaudio)
target_link_libraries(test_use_exe PRIVATE portaudio)
