=== debian/changelog ===
portaudio19 (19.7.0+git20251227.3270c9ae-0ubuntu1) resolute; urgency=medium

  * New upstream snapshot.
  * Refresh patches
  * Build-depend on autoconf-archive for AX_CHECK_COMPILE_FLAG
  * portaudio19-doc: remove deprecated pablio
  * Build with PulseAudio support
  * Add new PaPulseAudio_* symbols to libportaudio2
  * set PA_GIT_REVISION during build from Debian version

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 07 Jan 2026 02:04:58 +0100
