=== debian/changelog ===
portaudio19 (19.7.0+git20260206.e1b70d33-0ubuntu1) resolute; urgency=medium

  * New upstream snapshot.

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 06 Feb 2026 00:38:48 +0100
